###################################
##### Maven
###################################
image: maven:3.5.3-jdk-8

variables:
  # This will supress any download for dependencies and plugins or upload messages which would clutter the console log.
  # `showDateTime` will show the passed time in milliseconds. You need to specify `--batch-mode` to make this work.
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"
  # As of Maven 3.3.0 instead of this you may define these options in `.mvn/maven.config` so the same config is used
  # when running from the command line.
  # `installAtEnd` and `deployAtEnd` are only effective with recent version of the corresponding plugins.
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"

  #sonarcloud:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task

stages:
  - build
  - test 
  - sonarcloud-check
  #- package
  #- verify
  - deploy

########
# parallel build npm FE
########
#build:frontend:
#  stage: build
#  script:
#    - cd Hallinto-core/ 
#    - ./buildAndRun.sh

############
# build mvn BE
############
build:maven:
  stage: build
  script:
    - cd Hallinto-core/ 
    - mvn clean package
  cache:
    key: "$CI_JOB_REF_NAME"
    paths:
      - .m2/repository
  artifacts:
    when: on_success
    name: "$CI_JOB_STAGE-$CI_COMMIT_REF_NAME"
    paths:  #bin unsicher ob  pfad stimmt:
      - Hallinto-core/target/*.war 

#package:docker:
#  stage: package
#  tags:
#    - dind
#  image: docker:latest
#  services:
#   - docker:dind
#  variables:
#    CONTAINER_IMAGE: de.hallinto.core/hallinto-core
#    DOCKER_DRIVER: overlay2
#  script: docker build --cache-from $CONTAINER_IMAGE:latest -t $CONTAINER_IMAGE:$CI_BUILD_REF -t $CONTAINER_IMAGE:latest .
#  dependencies:
#     - build:maven
junit-test:
  stage: test
  script:
    - cd Hallinto-core/ 
    - mvn $MAVEN_CLI_OPTS test

######### Deploy in Environment #################
# productive: http://ddop-sen-sose20.code-et-more.net
# test: http://staging.ddop-sen-sose20.code-et-more.net
deploy_staging_test:
  stage: deploy
  script:
    - echo "Deploy to staging server -- Test Environment"
  environment:
    name: temp_staging_test
    url: http://staging.ddop-sen-sose20.code-et-more.net
  only:
    - master

deploy_staging_prod:
  stage: deploy
  script:
    - echo "Deploy to staging server -- Productive Environment"
  environment:
    name: temp_staging_prod
    url: http://ddop-sen-sose20.code-et-more.net
  only:
    - master

###############
## sonarcloud
##############
sonarcloud-check:
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - cd Hallinto-core/ 
    - mvn verify sonar:sonar
  only:
    - merge_requests
    - master
    - develop
